package no.ntnu.idatt1002.demo.controller;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ComboBox;
import javafx.scene.control.TextField;

import javafx.stage.Stage;
import no.ntnu.idatt1002.demo.data.Budget.BudgetItem;
import no.ntnu.idatt1002.demo.data.Economics.ExpenseCategory;

public class AddBudgetController {

    BudgetItem newBudgetItem = null;

    BudgetItem chosenBudgetItem = null;
    @FXML
    private ComboBox<ExpenseCategory> categoryVariable;
    @FXML
    private TextField amountVariable;
    @FXML
    private TextField descriptionVariable;


    @FXML
    private Button addButton;

    @FXML
    private Button cancelButton;

    @FXML
    public void initialize(){
        ObservableList<ExpenseCategory> expenseCategories = FXCollections.observableArrayList(
                ExpenseCategory.values());
        categoryVariable.setItems(expenseCategories);
        categoryVariable.setPromptText("Category");
    }

    public ExpenseCategory getCategory(){
        return categoryVariable.getValue();
    }

    public BudgetItem getNewBudgetItem(){
        return this.newBudgetItem;
    }

    @FXML
    public void addBudget(ActionEvent event) {
        if(newBudgetItem == null){
            ExpenseCategory category = getCategory();
            System.out.println(category.toString());
            double amount = Double.parseDouble(amountVariable.getText());
            System.out.println(amount);
            String description = descriptionVariable.getText();
            newBudgetItem = new BudgetItem(amount, description, category);
        }
        final Node source = (Node) event.getSource();
        final Stage stage = (Stage) source.getScene().getWindow();
        stage.close();
    }
}
